/**
 */
package FaultTree.provider;


import FaultTree.FaultTreeFactory;
import FaultTree.FaultTreePackage;
import FaultTree.Root;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link FaultTree.Root} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class RootItemProvider
	extends ItemProviderAdapter
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RootItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

		}
		return itemPropertyDescriptors;
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(FaultTreePackage.Literals.ROOT__HAZARD);
			childrenFeatures.add(FaultTreePackage.Literals.ROOT__GATE);
			childrenFeatures.add(FaultTreePackage.Literals.ROOT__EVENT);
			childrenFeatures.add(FaultTreePackage.Literals.ROOT__FAILURE_INSTANCE);
			childrenFeatures.add(FaultTreePackage.Literals.ROOT__FAILURE_TYPE);
			childrenFeatures.add(FaultTreePackage.Literals.ROOT__ERROR_INSTANCE);
			childrenFeatures.add(FaultTreePackage.Literals.ROOT__ERROR_TYPE);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns Root.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Root"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		return getString("_UI_Root_type");
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(Root.class)) {
			case FaultTreePackage.ROOT__HAZARD:
			case FaultTreePackage.ROOT__GATE:
			case FaultTreePackage.ROOT__EVENT:
			case FaultTreePackage.ROOT__FAILURE_INSTANCE:
			case FaultTreePackage.ROOT__FAILURE_TYPE:
			case FaultTreePackage.ROOT__ERROR_INSTANCE:
			case FaultTreePackage.ROOT__ERROR_TYPE:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(FaultTreePackage.Literals.ROOT__HAZARD,
				 FaultTreeFactory.eINSTANCE.createHazard()));

		newChildDescriptors.add
			(createChildParameter
				(FaultTreePackage.Literals.ROOT__GATE,
				 FaultTreeFactory.eINSTANCE.createOR()));

		newChildDescriptors.add
			(createChildParameter
				(FaultTreePackage.Literals.ROOT__GATE,
				 FaultTreeFactory.eINSTANCE.createAND()));

		newChildDescriptors.add
			(createChildParameter
				(FaultTreePackage.Literals.ROOT__GATE,
				 FaultTreeFactory.eINSTANCE.createXOR()));

		newChildDescriptors.add
			(createChildParameter
				(FaultTreePackage.Literals.ROOT__GATE,
				 FaultTreeFactory.eINSTANCE.createPriorAND()));

		newChildDescriptors.add
			(createChildParameter
				(FaultTreePackage.Literals.ROOT__GATE,
				 FaultTreeFactory.eINSTANCE.createInhibit()));

		newChildDescriptors.add
			(createChildParameter
				(FaultTreePackage.Literals.ROOT__EVENT,
				 FaultTreeFactory.eINSTANCE.createHazard()));

		newChildDescriptors.add
			(createChildParameter
				(FaultTreePackage.Literals.ROOT__EVENT,
				 FaultTreeFactory.eINSTANCE.createIntermediateEvent()));

		newChildDescriptors.add
			(createChildParameter
				(FaultTreePackage.Literals.ROOT__EVENT,
				 FaultTreeFactory.eINSTANCE.createBasicEvent()));

		newChildDescriptors.add
			(createChildParameter
				(FaultTreePackage.Literals.ROOT__EVENT,
				 FaultTreeFactory.eINSTANCE.createUndevelopedEvent()));

		newChildDescriptors.add
			(createChildParameter
				(FaultTreePackage.Literals.ROOT__FAILURE_INSTANCE,
				 FaultTreeFactory.eINSTANCE.createFailureInstance()));

		newChildDescriptors.add
			(createChildParameter
				(FaultTreePackage.Literals.ROOT__FAILURE_TYPE,
				 FaultTreeFactory.eINSTANCE.createFailureType()));

		newChildDescriptors.add
			(createChildParameter
				(FaultTreePackage.Literals.ROOT__ERROR_INSTANCE,
				 FaultTreeFactory.eINSTANCE.createErrorInstance()));

		newChildDescriptors.add
			(createChildParameter
				(FaultTreePackage.Literals.ROOT__ERROR_TYPE,
				 FaultTreeFactory.eINSTANCE.createErrorType()));
	}

	/**
	 * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getCreateChildText(Object owner, Object feature, Object child, Collection<?> selection) {
		Object childFeature = feature;
		Object childObject = child;

		boolean qualify =
			childFeature == FaultTreePackage.Literals.ROOT__HAZARD ||
			childFeature == FaultTreePackage.Literals.ROOT__EVENT;

		if (qualify) {
			return getString
				("_UI_CreateChild_text2",
				 new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
		}
		return super.getCreateChildText(owner, feature, child, selection);
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return FaultTreeEditPlugin.INSTANCE;
	}

}
