/**
 */
package FaultTree;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Failure Instance</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link FaultTree.FailureInstance#getType <em>Type</em>}</li>
 *   <li>{@link FaultTree.FailureInstance#getRoot <em>Root</em>}</li>
 *   <li>{@link FaultTree.FailureInstance#getPreviousFailure <em>Previous Failure</em>}</li>
 *   <li>{@link FaultTree.FailureInstance#getPreviousError <em>Previous Error</em>}</li>
 *   <li>{@link FaultTree.FailureInstance#getEvent <em>Event</em>}</li>
 *   <li>{@link FaultTree.FailureInstance#getName <em>Name</em>}</li>
 * </ul>
 * </p>
 *
 * @see FaultTree.FaultTreePackage#getFailureInstance()
 * @model
 * @generated
 */
public interface FailureInstance extends EObject {
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see FaultTree.FaultTreePackage#getFailureInstance_Name()
	 * @model
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link FaultTree.FailureInstance#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link FaultTree.FailureType#getInstance <em>Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' reference.
	 * @see #setType(FailureType)
	 * @see FaultTree.FaultTreePackage#getFailureInstance_Type()
	 * @see FaultTree.FailureType#getInstance
	 * @model opposite="instance" required="true"
	 * @generated
	 */
	FailureType getType();

	/**
	 * Sets the value of the '{@link FaultTree.FailureInstance#getType <em>Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' reference.
	 * @see #getType()
	 * @generated
	 */
	void setType(FailureType value);

	/**
	 * Returns the value of the '<em><b>Root</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link FaultTree.Root#getFailure_instance <em>Failure instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Root</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Root</em>' container reference.
	 * @see #setRoot(Root)
	 * @see FaultTree.FaultTreePackage#getFailureInstance_Root()
	 * @see FaultTree.Root#getFailure_instance
	 * @model opposite="failure_instance" transient="false"
	 * @generated
	 */
	Root getRoot();

	/**
	 * Sets the value of the '{@link FaultTree.FailureInstance#getRoot <em>Root</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Root</em>' container reference.
	 * @see #getRoot()
	 * @generated
	 */
	void setRoot(Root value);

	/**
	 * Returns the value of the '<em><b>Previous Failure</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Previous Failure</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Previous Failure</em>' reference.
	 * @see #setPreviousFailure(FailureInstance)
	 * @see FaultTree.FaultTreePackage#getFailureInstance_PreviousFailure()
	 * @model
	 * @generated
	 */
	FailureInstance getPreviousFailure();

	/**
	 * Sets the value of the '{@link FaultTree.FailureInstance#getPreviousFailure <em>Previous Failure</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Previous Failure</em>' reference.
	 * @see #getPreviousFailure()
	 * @generated
	 */
	void setPreviousFailure(FailureInstance value);

	/**
	 * Returns the value of the '<em><b>Previous Error</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Previous Error</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Previous Error</em>' reference.
	 * @see #setPreviousError(ErrorInstance)
	 * @see FaultTree.FaultTreePackage#getFailureInstance_PreviousError()
	 * @model
	 * @generated
	 */
	ErrorInstance getPreviousError();

	/**
	 * Sets the value of the '{@link FaultTree.FailureInstance#getPreviousError <em>Previous Error</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Previous Error</em>' reference.
	 * @see #getPreviousError()
	 * @generated
	 */
	void setPreviousError(ErrorInstance value);

	/**
	 * Returns the value of the '<em><b>Event</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link FaultTree.IntermediateEvent#getInstance <em>Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Event</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event</em>' reference.
	 * @see #setEvent(IntermediateEvent)
	 * @see FaultTree.FaultTreePackage#getFailureInstance_Event()
	 * @see FaultTree.IntermediateEvent#getInstance
	 * @model opposite="instance"
	 * @generated
	 */
	IntermediateEvent getEvent();

	/**
	 * Sets the value of the '{@link FaultTree.FailureInstance#getEvent <em>Event</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Event</em>' reference.
	 * @see #getEvent()
	 * @generated
	 */
	void setEvent(IntermediateEvent value);

} // FailureInstance
