/**
 */
package FaultTree;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see FaultTree.FaultTreeFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/OCL/Import ecore='http://www.eclipse.org/emf/2002/Ecore#/'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore invocationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' settingDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' validationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot'"
 * @generated
 */
public interface FaultTreePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "FaultTree";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://FaultTree/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "FaultTree";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	FaultTreePackage eINSTANCE = FaultTree.impl.FaultTreePackageImpl.init();

	/**
	 * The meta object id for the '{@link FaultTree.impl.EventImpl <em>Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see FaultTree.impl.EventImpl
	 * @see FaultTree.impl.FaultTreePackageImpl#getEvent()
	 * @generated
	 */
	int EVENT = 2;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT__DESCRIPTION = 0;

	/**
	 * The feature id for the '<em><b>Input Gate</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT__INPUT_GATE = 1;

	/**
	 * The feature id for the '<em><b>Output Gate</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT__OUTPUT_GATE = 2;

	/**
	 * The feature id for the '<em><b>Root</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT__ROOT = 3;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT__NAME = 4;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT__ID = 5;

	/**
	 * The number of structural features of the '<em>Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_FEATURE_COUNT = 6;

	/**
	 * The meta object id for the '{@link FaultTree.impl.HazardImpl <em>Hazard</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see FaultTree.impl.HazardImpl
	 * @see FaultTree.impl.FaultTreePackageImpl#getHazard()
	 * @generated
	 */
	int HAZARD = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HAZARD__DESCRIPTION = EVENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Input Gate</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HAZARD__INPUT_GATE = EVENT__INPUT_GATE;

	/**
	 * The feature id for the '<em><b>Output Gate</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HAZARD__OUTPUT_GATE = EVENT__OUTPUT_GATE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HAZARD__ROOT = EVENT__ROOT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HAZARD__NAME = EVENT__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HAZARD__ID = EVENT__ID;

	/**
	 * The feature id for the '<em><b>In Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HAZARD__IN_EVENT = EVENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Hazard</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HAZARD_FEATURE_COUNT = EVENT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link FaultTree.impl.GateImpl <em>Gate</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see FaultTree.impl.GateImpl
	 * @see FaultTree.impl.FaultTreePackageImpl#getGate()
	 * @generated
	 */
	int GATE = 1;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GATE__ID = 0;

	/**
	 * The feature id for the '<em><b>Input Gates</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GATE__INPUT_GATES = 1;

	/**
	 * The feature id for the '<em><b>Input Events</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GATE__INPUT_EVENTS = 2;

	/**
	 * The feature id for the '<em><b>Output Gate</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GATE__OUTPUT_GATE = 3;

	/**
	 * The feature id for the '<em><b>Output Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GATE__OUTPUT_EVENT = 4;

	/**
	 * The feature id for the '<em><b>Root</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GATE__ROOT = 5;

	/**
	 * The number of structural features of the '<em>Gate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GATE_FEATURE_COUNT = 6;

	/**
	 * The meta object id for the '{@link FaultTree.impl.IntermediateEventImpl <em>Intermediate Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see FaultTree.impl.IntermediateEventImpl
	 * @see FaultTree.impl.FaultTreePackageImpl#getIntermediateEvent()
	 * @generated
	 */
	int INTERMEDIATE_EVENT = 3;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_EVENT__DESCRIPTION = EVENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Input Gate</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_EVENT__INPUT_GATE = EVENT__INPUT_GATE;

	/**
	 * The feature id for the '<em><b>Output Gate</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_EVENT__OUTPUT_GATE = EVENT__OUTPUT_GATE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_EVENT__ROOT = EVENT__ROOT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_EVENT__NAME = EVENT__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_EVENT__ID = EVENT__ID;

	/**
	 * The feature id for the '<em><b>Instance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_EVENT__INSTANCE = EVENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>In Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_EVENT__IN_EVENT = EVENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Out Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_EVENT__OUT_EVENT = EVENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Intermediate Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_EVENT_FEATURE_COUNT = EVENT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link FaultTree.impl.FailureTypeImpl <em>Failure Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see FaultTree.impl.FailureTypeImpl
	 * @see FaultTree.impl.FaultTreePackageImpl#getFailureType()
	 * @generated
	 */
	int FAILURE_TYPE = 4;

	/**
	 * The feature id for the '<em><b>Instance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_TYPE__INSTANCE = 0;

	/**
	 * The feature id for the '<em><b>Root</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_TYPE__ROOT = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_TYPE__NAME = 2;

	/**
	 * The number of structural features of the '<em>Failure Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link FaultTree.impl.FailureInstanceImpl <em>Failure Instance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see FaultTree.impl.FailureInstanceImpl
	 * @see FaultTree.impl.FaultTreePackageImpl#getFailureInstance()
	 * @generated
	 */
	int FAILURE_INSTANCE = 5;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_INSTANCE__TYPE = 0;

	/**
	 * The feature id for the '<em><b>Root</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_INSTANCE__ROOT = 1;

	/**
	 * The feature id for the '<em><b>Previous Failure</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_INSTANCE__PREVIOUS_FAILURE = 2;

	/**
	 * The feature id for the '<em><b>Previous Error</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_INSTANCE__PREVIOUS_ERROR = 3;

	/**
	 * The feature id for the '<em><b>Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_INSTANCE__EVENT = 4;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_INSTANCE__NAME = 5;

	/**
	 * The number of structural features of the '<em>Failure Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_INSTANCE_FEATURE_COUNT = 6;

	/**
	 * The meta object id for the '{@link FaultTree.impl.BasicEventImpl <em>Basic Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see FaultTree.impl.BasicEventImpl
	 * @see FaultTree.impl.FaultTreePackageImpl#getBasicEvent()
	 * @generated
	 */
	int BASIC_EVENT = 6;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_EVENT__DESCRIPTION = EVENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Input Gate</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_EVENT__INPUT_GATE = EVENT__INPUT_GATE;

	/**
	 * The feature id for the '<em><b>Output Gate</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_EVENT__OUTPUT_GATE = EVENT__OUTPUT_GATE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_EVENT__ROOT = EVENT__ROOT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_EVENT__NAME = EVENT__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_EVENT__ID = EVENT__ID;

	/**
	 * The feature id for the '<em><b>Instance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_EVENT__INSTANCE = EVENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Probability</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_EVENT__PROBABILITY = EVENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Out Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_EVENT__OUT_EVENT = EVENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Basic Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASIC_EVENT_FEATURE_COUNT = EVENT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link FaultTree.impl.UndevelopedEventImpl <em>Undeveloped Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see FaultTree.impl.UndevelopedEventImpl
	 * @see FaultTree.impl.FaultTreePackageImpl#getUndevelopedEvent()
	 * @generated
	 */
	int UNDEVELOPED_EVENT = 7;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNDEVELOPED_EVENT__DESCRIPTION = EVENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Input Gate</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNDEVELOPED_EVENT__INPUT_GATE = EVENT__INPUT_GATE;

	/**
	 * The feature id for the '<em><b>Output Gate</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNDEVELOPED_EVENT__OUTPUT_GATE = EVENT__OUTPUT_GATE;

	/**
	 * The feature id for the '<em><b>Root</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNDEVELOPED_EVENT__ROOT = EVENT__ROOT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNDEVELOPED_EVENT__NAME = EVENT__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNDEVELOPED_EVENT__ID = EVENT__ID;

	/**
	 * The number of structural features of the '<em>Undeveloped Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNDEVELOPED_EVENT_FEATURE_COUNT = EVENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link FaultTree.impl.ErrorTypeImpl <em>Error Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see FaultTree.impl.ErrorTypeImpl
	 * @see FaultTree.impl.FaultTreePackageImpl#getErrorType()
	 * @generated
	 */
	int ERROR_TYPE = 8;

	/**
	 * The feature id for the '<em><b>Error</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ERROR_TYPE__ERROR = 0;

	/**
	 * The feature id for the '<em><b>Root</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ERROR_TYPE__ROOT = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ERROR_TYPE__NAME = 2;

	/**
	 * The number of structural features of the '<em>Error Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ERROR_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link FaultTree.impl.ErrorInstanceImpl <em>Error Instance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see FaultTree.impl.ErrorInstanceImpl
	 * @see FaultTree.impl.FaultTreePackageImpl#getErrorInstance()
	 * @generated
	 */
	int ERROR_INSTANCE = 9;

	/**
	 * The feature id for the '<em><b>Error</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ERROR_INSTANCE__ERROR = 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ERROR_INSTANCE__TYPE = 1;

	/**
	 * The feature id for the '<em><b>Root</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ERROR_INSTANCE__ROOT = 2;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ERROR_INSTANCE__NAME = 3;

	/**
	 * The number of structural features of the '<em>Error Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ERROR_INSTANCE_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link FaultTree.impl.ORImpl <em>OR</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see FaultTree.impl.ORImpl
	 * @see FaultTree.impl.FaultTreePackageImpl#getOR()
	 * @generated
	 */
	int OR = 10;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR__ID = GATE__ID;

	/**
	 * The feature id for the '<em><b>Input Gates</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR__INPUT_GATES = GATE__INPUT_GATES;

	/**
	 * The feature id for the '<em><b>Input Events</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR__INPUT_EVENTS = GATE__INPUT_EVENTS;

	/**
	 * The feature id for the '<em><b>Output Gate</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR__OUTPUT_GATE = GATE__OUTPUT_GATE;

	/**
	 * The feature id for the '<em><b>Output Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR__OUTPUT_EVENT = GATE__OUTPUT_EVENT;

	/**
	 * The feature id for the '<em><b>Root</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR__ROOT = GATE__ROOT;

	/**
	 * The number of structural features of the '<em>OR</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR_FEATURE_COUNT = GATE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link FaultTree.impl.ANDImpl <em>AND</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see FaultTree.impl.ANDImpl
	 * @see FaultTree.impl.FaultTreePackageImpl#getAND()
	 * @generated
	 */
	int AND = 11;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND__ID = GATE__ID;

	/**
	 * The feature id for the '<em><b>Input Gates</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND__INPUT_GATES = GATE__INPUT_GATES;

	/**
	 * The feature id for the '<em><b>Input Events</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND__INPUT_EVENTS = GATE__INPUT_EVENTS;

	/**
	 * The feature id for the '<em><b>Output Gate</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND__OUTPUT_GATE = GATE__OUTPUT_GATE;

	/**
	 * The feature id for the '<em><b>Output Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND__OUTPUT_EVENT = GATE__OUTPUT_EVENT;

	/**
	 * The feature id for the '<em><b>Root</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND__ROOT = GATE__ROOT;

	/**
	 * The number of structural features of the '<em>AND</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND_FEATURE_COUNT = GATE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link FaultTree.impl.XORImpl <em>XOR</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see FaultTree.impl.XORImpl
	 * @see FaultTree.impl.FaultTreePackageImpl#getXOR()
	 * @generated
	 */
	int XOR = 12;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XOR__ID = GATE__ID;

	/**
	 * The feature id for the '<em><b>Input Gates</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XOR__INPUT_GATES = GATE__INPUT_GATES;

	/**
	 * The feature id for the '<em><b>Input Events</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XOR__INPUT_EVENTS = GATE__INPUT_EVENTS;

	/**
	 * The feature id for the '<em><b>Output Gate</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XOR__OUTPUT_GATE = GATE__OUTPUT_GATE;

	/**
	 * The feature id for the '<em><b>Output Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XOR__OUTPUT_EVENT = GATE__OUTPUT_EVENT;

	/**
	 * The feature id for the '<em><b>Root</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XOR__ROOT = GATE__ROOT;

	/**
	 * The number of structural features of the '<em>XOR</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XOR_FEATURE_COUNT = GATE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link FaultTree.impl.PriorANDImpl <em>Prior AND</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see FaultTree.impl.PriorANDImpl
	 * @see FaultTree.impl.FaultTreePackageImpl#getPriorAND()
	 * @generated
	 */
	int PRIOR_AND = 13;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIOR_AND__ID = GATE__ID;

	/**
	 * The feature id for the '<em><b>Input Gates</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIOR_AND__INPUT_GATES = GATE__INPUT_GATES;

	/**
	 * The feature id for the '<em><b>Input Events</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIOR_AND__INPUT_EVENTS = GATE__INPUT_EVENTS;

	/**
	 * The feature id for the '<em><b>Output Gate</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIOR_AND__OUTPUT_GATE = GATE__OUTPUT_GATE;

	/**
	 * The feature id for the '<em><b>Output Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIOR_AND__OUTPUT_EVENT = GATE__OUTPUT_EVENT;

	/**
	 * The feature id for the '<em><b>Root</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIOR_AND__ROOT = GATE__ROOT;

	/**
	 * The number of structural features of the '<em>Prior AND</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRIOR_AND_FEATURE_COUNT = GATE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link FaultTree.impl.InhibitImpl <em>Inhibit</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see FaultTree.impl.InhibitImpl
	 * @see FaultTree.impl.FaultTreePackageImpl#getInhibit()
	 * @generated
	 */
	int INHIBIT = 14;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INHIBIT__ID = GATE__ID;

	/**
	 * The feature id for the '<em><b>Input Gates</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INHIBIT__INPUT_GATES = GATE__INPUT_GATES;

	/**
	 * The feature id for the '<em><b>Input Events</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INHIBIT__INPUT_EVENTS = GATE__INPUT_EVENTS;

	/**
	 * The feature id for the '<em><b>Output Gate</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INHIBIT__OUTPUT_GATE = GATE__OUTPUT_GATE;

	/**
	 * The feature id for the '<em><b>Output Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INHIBIT__OUTPUT_EVENT = GATE__OUTPUT_EVENT;

	/**
	 * The feature id for the '<em><b>Root</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INHIBIT__ROOT = GATE__ROOT;

	/**
	 * The number of structural features of the '<em>Inhibit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INHIBIT_FEATURE_COUNT = GATE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link FaultTree.impl.RootImpl <em>Root</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see FaultTree.impl.RootImpl
	 * @see FaultTree.impl.FaultTreePackageImpl#getRoot()
	 * @generated
	 */
	int ROOT = 15;

	/**
	 * The feature id for the '<em><b>Hazard</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT__HAZARD = 0;

	/**
	 * The feature id for the '<em><b>Gate</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT__GATE = 1;

	/**
	 * The feature id for the '<em><b>Event</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT__EVENT = 2;

	/**
	 * The feature id for the '<em><b>Failure instance</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT__FAILURE_INSTANCE = 3;

	/**
	 * The feature id for the '<em><b>Failure type</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT__FAILURE_TYPE = 4;

	/**
	 * The feature id for the '<em><b>Error instance</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT__ERROR_INSTANCE = 5;

	/**
	 * The feature id for the '<em><b>Error type</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT__ERROR_TYPE = 6;

	/**
	 * The number of structural features of the '<em>Root</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT_FEATURE_COUNT = 7;


	/**
	 * Returns the meta object for class '{@link FaultTree.Hazard <em>Hazard</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hazard</em>'.
	 * @see FaultTree.Hazard
	 * @generated
	 */
	EClass getHazard();

	/**
	 * Returns the meta object for the reference '{@link FaultTree.Hazard#getInEvent <em>In Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>In Event</em>'.
	 * @see FaultTree.Hazard#getInEvent()
	 * @see #getHazard()
	 * @generated
	 */
	EReference getHazard_InEvent();

	/**
	 * Returns the meta object for class '{@link FaultTree.Gate <em>Gate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Gate</em>'.
	 * @see FaultTree.Gate
	 * @generated
	 */
	EClass getGate();

	/**
	 * Returns the meta object for the attribute '{@link FaultTree.Gate#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see FaultTree.Gate#getId()
	 * @see #getGate()
	 * @generated
	 */
	EAttribute getGate_Id();

	/**
	 * Returns the meta object for the reference list '{@link FaultTree.Gate#getInputGates <em>Input Gates</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Input Gates</em>'.
	 * @see FaultTree.Gate#getInputGates()
	 * @see #getGate()
	 * @generated
	 */
	EReference getGate_InputGates();

	/**
	 * Returns the meta object for the reference list '{@link FaultTree.Gate#getInputEvents <em>Input Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Input Events</em>'.
	 * @see FaultTree.Gate#getInputEvents()
	 * @see #getGate()
	 * @generated
	 */
	EReference getGate_InputEvents();

	/**
	 * Returns the meta object for the reference '{@link FaultTree.Gate#getOutputGate <em>Output Gate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Output Gate</em>'.
	 * @see FaultTree.Gate#getOutputGate()
	 * @see #getGate()
	 * @generated
	 */
	EReference getGate_OutputGate();

	/**
	 * Returns the meta object for the reference '{@link FaultTree.Gate#getOutputEvent <em>Output Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Output Event</em>'.
	 * @see FaultTree.Gate#getOutputEvent()
	 * @see #getGate()
	 * @generated
	 */
	EReference getGate_OutputEvent();

	/**
	 * Returns the meta object for the container reference '{@link FaultTree.Gate#getRoot <em>Root</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Root</em>'.
	 * @see FaultTree.Gate#getRoot()
	 * @see #getGate()
	 * @generated
	 */
	EReference getGate_Root();

	/**
	 * Returns the meta object for class '{@link FaultTree.Event <em>Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event</em>'.
	 * @see FaultTree.Event
	 * @generated
	 */
	EClass getEvent();

	/**
	 * Returns the meta object for the attribute '{@link FaultTree.Event#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see FaultTree.Event#getName()
	 * @see #getEvent()
	 * @generated
	 */
	EAttribute getEvent_Name();

	/**
	 * Returns the meta object for the attribute '{@link FaultTree.Event#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see FaultTree.Event#getId()
	 * @see #getEvent()
	 * @generated
	 */
	EAttribute getEvent_Id();

	/**
	 * Returns the meta object for the attribute '{@link FaultTree.Event#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see FaultTree.Event#getDescription()
	 * @see #getEvent()
	 * @generated
	 */
	EAttribute getEvent_Description();

	/**
	 * Returns the meta object for the reference '{@link FaultTree.Event#getInputGate <em>Input Gate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Input Gate</em>'.
	 * @see FaultTree.Event#getInputGate()
	 * @see #getEvent()
	 * @generated
	 */
	EReference getEvent_InputGate();

	/**
	 * Returns the meta object for the reference '{@link FaultTree.Event#getOutputGate <em>Output Gate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Output Gate</em>'.
	 * @see FaultTree.Event#getOutputGate()
	 * @see #getEvent()
	 * @generated
	 */
	EReference getEvent_OutputGate();

	/**
	 * Returns the meta object for the container reference '{@link FaultTree.Event#getRoot <em>Root</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Root</em>'.
	 * @see FaultTree.Event#getRoot()
	 * @see #getEvent()
	 * @generated
	 */
	EReference getEvent_Root();

	/**
	 * Returns the meta object for class '{@link FaultTree.IntermediateEvent <em>Intermediate Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Intermediate Event</em>'.
	 * @see FaultTree.IntermediateEvent
	 * @generated
	 */
	EClass getIntermediateEvent();

	/**
	 * Returns the meta object for the reference list '{@link FaultTree.IntermediateEvent#getInstance <em>Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Instance</em>'.
	 * @see FaultTree.IntermediateEvent#getInstance()
	 * @see #getIntermediateEvent()
	 * @generated
	 */
	EReference getIntermediateEvent_Instance();

	/**
	 * Returns the meta object for the reference '{@link FaultTree.IntermediateEvent#getInEvent <em>In Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>In Event</em>'.
	 * @see FaultTree.IntermediateEvent#getInEvent()
	 * @see #getIntermediateEvent()
	 * @generated
	 */
	EReference getIntermediateEvent_InEvent();

	/**
	 * Returns the meta object for the reference '{@link FaultTree.IntermediateEvent#getOutEvent <em>Out Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Out Event</em>'.
	 * @see FaultTree.IntermediateEvent#getOutEvent()
	 * @see #getIntermediateEvent()
	 * @generated
	 */
	EReference getIntermediateEvent_OutEvent();

	/**
	 * Returns the meta object for class '{@link FaultTree.FailureType <em>Failure Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Failure Type</em>'.
	 * @see FaultTree.FailureType
	 * @generated
	 */
	EClass getFailureType();

	/**
	 * Returns the meta object for the reference list '{@link FaultTree.FailureType#getInstance <em>Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Instance</em>'.
	 * @see FaultTree.FailureType#getInstance()
	 * @see #getFailureType()
	 * @generated
	 */
	EReference getFailureType_Instance();

	/**
	 * Returns the meta object for the attribute '{@link FaultTree.FailureType#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see FaultTree.FailureType#getName()
	 * @see #getFailureType()
	 * @generated
	 */
	EAttribute getFailureType_Name();

	/**
	 * Returns the meta object for the container reference '{@link FaultTree.FailureType#getRoot <em>Root</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Root</em>'.
	 * @see FaultTree.FailureType#getRoot()
	 * @see #getFailureType()
	 * @generated
	 */
	EReference getFailureType_Root();

	/**
	 * Returns the meta object for class '{@link FaultTree.FailureInstance <em>Failure Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Failure Instance</em>'.
	 * @see FaultTree.FailureInstance
	 * @generated
	 */
	EClass getFailureInstance();

	/**
	 * Returns the meta object for the attribute '{@link FaultTree.FailureInstance#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see FaultTree.FailureInstance#getName()
	 * @see #getFailureInstance()
	 * @generated
	 */
	EAttribute getFailureInstance_Name();

	/**
	 * Returns the meta object for the reference '{@link FaultTree.FailureInstance#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Type</em>'.
	 * @see FaultTree.FailureInstance#getType()
	 * @see #getFailureInstance()
	 * @generated
	 */
	EReference getFailureInstance_Type();

	/**
	 * Returns the meta object for the container reference '{@link FaultTree.FailureInstance#getRoot <em>Root</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Root</em>'.
	 * @see FaultTree.FailureInstance#getRoot()
	 * @see #getFailureInstance()
	 * @generated
	 */
	EReference getFailureInstance_Root();

	/**
	 * Returns the meta object for the reference '{@link FaultTree.FailureInstance#getPreviousFailure <em>Previous Failure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Previous Failure</em>'.
	 * @see FaultTree.FailureInstance#getPreviousFailure()
	 * @see #getFailureInstance()
	 * @generated
	 */
	EReference getFailureInstance_PreviousFailure();

	/**
	 * Returns the meta object for the reference '{@link FaultTree.FailureInstance#getPreviousError <em>Previous Error</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Previous Error</em>'.
	 * @see FaultTree.FailureInstance#getPreviousError()
	 * @see #getFailureInstance()
	 * @generated
	 */
	EReference getFailureInstance_PreviousError();

	/**
	 * Returns the meta object for the reference '{@link FaultTree.FailureInstance#getEvent <em>Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Event</em>'.
	 * @see FaultTree.FailureInstance#getEvent()
	 * @see #getFailureInstance()
	 * @generated
	 */
	EReference getFailureInstance_Event();

	/**
	 * Returns the meta object for class '{@link FaultTree.BasicEvent <em>Basic Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Basic Event</em>'.
	 * @see FaultTree.BasicEvent
	 * @generated
	 */
	EClass getBasicEvent();

	/**
	 * Returns the meta object for the reference list '{@link FaultTree.BasicEvent#getInstance <em>Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Instance</em>'.
	 * @see FaultTree.BasicEvent#getInstance()
	 * @see #getBasicEvent()
	 * @generated
	 */
	EReference getBasicEvent_Instance();

	/**
	 * Returns the meta object for the attribute '{@link FaultTree.BasicEvent#getProbability <em>Probability</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Probability</em>'.
	 * @see FaultTree.BasicEvent#getProbability()
	 * @see #getBasicEvent()
	 * @generated
	 */
	EAttribute getBasicEvent_Probability();

	/**
	 * Returns the meta object for the reference '{@link FaultTree.BasicEvent#getOutEvent <em>Out Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Out Event</em>'.
	 * @see FaultTree.BasicEvent#getOutEvent()
	 * @see #getBasicEvent()
	 * @generated
	 */
	EReference getBasicEvent_OutEvent();

	/**
	 * Returns the meta object for class '{@link FaultTree.UndevelopedEvent <em>Undeveloped Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Undeveloped Event</em>'.
	 * @see FaultTree.UndevelopedEvent
	 * @generated
	 */
	EClass getUndevelopedEvent();

	/**
	 * Returns the meta object for class '{@link FaultTree.ErrorType <em>Error Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Error Type</em>'.
	 * @see FaultTree.ErrorType
	 * @generated
	 */
	EClass getErrorType();

	/**
	 * Returns the meta object for the attribute '{@link FaultTree.ErrorType#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see FaultTree.ErrorType#getName()
	 * @see #getErrorType()
	 * @generated
	 */
	EAttribute getErrorType_Name();

	/**
	 * Returns the meta object for the reference list '{@link FaultTree.ErrorType#getError <em>Error</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Error</em>'.
	 * @see FaultTree.ErrorType#getError()
	 * @see #getErrorType()
	 * @generated
	 */
	EReference getErrorType_Error();

	/**
	 * Returns the meta object for the container reference '{@link FaultTree.ErrorType#getRoot <em>Root</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Root</em>'.
	 * @see FaultTree.ErrorType#getRoot()
	 * @see #getErrorType()
	 * @generated
	 */
	EReference getErrorType_Root();

	/**
	 * Returns the meta object for class '{@link FaultTree.ErrorInstance <em>Error Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Error Instance</em>'.
	 * @see FaultTree.ErrorInstance
	 * @generated
	 */
	EClass getErrorInstance();

	/**
	 * Returns the meta object for the attribute '{@link FaultTree.ErrorInstance#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see FaultTree.ErrorInstance#getName()
	 * @see #getErrorInstance()
	 * @generated
	 */
	EAttribute getErrorInstance_Name();

	/**
	 * Returns the meta object for the reference '{@link FaultTree.ErrorInstance#getError <em>Error</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Error</em>'.
	 * @see FaultTree.ErrorInstance#getError()
	 * @see #getErrorInstance()
	 * @generated
	 */
	EReference getErrorInstance_Error();

	/**
	 * Returns the meta object for the reference '{@link FaultTree.ErrorInstance#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Type</em>'.
	 * @see FaultTree.ErrorInstance#getType()
	 * @see #getErrorInstance()
	 * @generated
	 */
	EReference getErrorInstance_Type();

	/**
	 * Returns the meta object for the container reference '{@link FaultTree.ErrorInstance#getRoot <em>Root</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Root</em>'.
	 * @see FaultTree.ErrorInstance#getRoot()
	 * @see #getErrorInstance()
	 * @generated
	 */
	EReference getErrorInstance_Root();

	/**
	 * Returns the meta object for class '{@link FaultTree.OR <em>OR</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>OR</em>'.
	 * @see FaultTree.OR
	 * @generated
	 */
	EClass getOR();

	/**
	 * Returns the meta object for class '{@link FaultTree.AND <em>AND</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>AND</em>'.
	 * @see FaultTree.AND
	 * @generated
	 */
	EClass getAND();

	/**
	 * Returns the meta object for class '{@link FaultTree.XOR <em>XOR</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>XOR</em>'.
	 * @see FaultTree.XOR
	 * @generated
	 */
	EClass getXOR();

	/**
	 * Returns the meta object for class '{@link FaultTree.PriorAND <em>Prior AND</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Prior AND</em>'.
	 * @see FaultTree.PriorAND
	 * @generated
	 */
	EClass getPriorAND();

	/**
	 * Returns the meta object for class '{@link FaultTree.Inhibit <em>Inhibit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Inhibit</em>'.
	 * @see FaultTree.Inhibit
	 * @generated
	 */
	EClass getInhibit();

	/**
	 * Returns the meta object for class '{@link FaultTree.Root <em>Root</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Root</em>'.
	 * @see FaultTree.Root
	 * @generated
	 */
	EClass getRoot();

	/**
	 * Returns the meta object for the containment reference '{@link FaultTree.Root#getHazard <em>Hazard</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Hazard</em>'.
	 * @see FaultTree.Root#getHazard()
	 * @see #getRoot()
	 * @generated
	 */
	EReference getRoot_Hazard();

	/**
	 * Returns the meta object for the containment reference list '{@link FaultTree.Root#getGate <em>Gate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Gate</em>'.
	 * @see FaultTree.Root#getGate()
	 * @see #getRoot()
	 * @generated
	 */
	EReference getRoot_Gate();

	/**
	 * Returns the meta object for the containment reference list '{@link FaultTree.Root#getEvent <em>Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Event</em>'.
	 * @see FaultTree.Root#getEvent()
	 * @see #getRoot()
	 * @generated
	 */
	EReference getRoot_Event();

	/**
	 * Returns the meta object for the containment reference list '{@link FaultTree.Root#getFailure_instance <em>Failure instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Failure instance</em>'.
	 * @see FaultTree.Root#getFailure_instance()
	 * @see #getRoot()
	 * @generated
	 */
	EReference getRoot_Failure_instance();

	/**
	 * Returns the meta object for the containment reference list '{@link FaultTree.Root#getFailure_type <em>Failure type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Failure type</em>'.
	 * @see FaultTree.Root#getFailure_type()
	 * @see #getRoot()
	 * @generated
	 */
	EReference getRoot_Failure_type();

	/**
	 * Returns the meta object for the containment reference list '{@link FaultTree.Root#getError_instance <em>Error instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Error instance</em>'.
	 * @see FaultTree.Root#getError_instance()
	 * @see #getRoot()
	 * @generated
	 */
	EReference getRoot_Error_instance();

	/**
	 * Returns the meta object for the containment reference list '{@link FaultTree.Root#getError_type <em>Error type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Error type</em>'.
	 * @see FaultTree.Root#getError_type()
	 * @see #getRoot()
	 * @generated
	 */
	EReference getRoot_Error_type();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	FaultTreeFactory getFaultTreeFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link FaultTree.impl.HazardImpl <em>Hazard</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see FaultTree.impl.HazardImpl
		 * @see FaultTree.impl.FaultTreePackageImpl#getHazard()
		 * @generated
		 */
		EClass HAZARD = eINSTANCE.getHazard();

		/**
		 * The meta object literal for the '<em><b>In Event</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference HAZARD__IN_EVENT = eINSTANCE.getHazard_InEvent();

		/**
		 * The meta object literal for the '{@link FaultTree.impl.GateImpl <em>Gate</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see FaultTree.impl.GateImpl
		 * @see FaultTree.impl.FaultTreePackageImpl#getGate()
		 * @generated
		 */
		EClass GATE = eINSTANCE.getGate();

		/**
		 * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GATE__ID = eINSTANCE.getGate_Id();

		/**
		 * The meta object literal for the '<em><b>Input Gates</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GATE__INPUT_GATES = eINSTANCE.getGate_InputGates();

		/**
		 * The meta object literal for the '<em><b>Input Events</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GATE__INPUT_EVENTS = eINSTANCE.getGate_InputEvents();

		/**
		 * The meta object literal for the '<em><b>Output Gate</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GATE__OUTPUT_GATE = eINSTANCE.getGate_OutputGate();

		/**
		 * The meta object literal for the '<em><b>Output Event</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GATE__OUTPUT_EVENT = eINSTANCE.getGate_OutputEvent();

		/**
		 * The meta object literal for the '<em><b>Root</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GATE__ROOT = eINSTANCE.getGate_Root();

		/**
		 * The meta object literal for the '{@link FaultTree.impl.EventImpl <em>Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see FaultTree.impl.EventImpl
		 * @see FaultTree.impl.FaultTreePackageImpl#getEvent()
		 * @generated
		 */
		EClass EVENT = eINSTANCE.getEvent();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EVENT__NAME = eINSTANCE.getEvent_Name();

		/**
		 * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EVENT__ID = eINSTANCE.getEvent_Id();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EVENT__DESCRIPTION = eINSTANCE.getEvent_Description();

		/**
		 * The meta object literal for the '<em><b>Input Gate</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT__INPUT_GATE = eINSTANCE.getEvent_InputGate();

		/**
		 * The meta object literal for the '<em><b>Output Gate</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT__OUTPUT_GATE = eINSTANCE.getEvent_OutputGate();

		/**
		 * The meta object literal for the '<em><b>Root</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT__ROOT = eINSTANCE.getEvent_Root();

		/**
		 * The meta object literal for the '{@link FaultTree.impl.IntermediateEventImpl <em>Intermediate Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see FaultTree.impl.IntermediateEventImpl
		 * @see FaultTree.impl.FaultTreePackageImpl#getIntermediateEvent()
		 * @generated
		 */
		EClass INTERMEDIATE_EVENT = eINSTANCE.getIntermediateEvent();

		/**
		 * The meta object literal for the '<em><b>Instance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERMEDIATE_EVENT__INSTANCE = eINSTANCE.getIntermediateEvent_Instance();

		/**
		 * The meta object literal for the '<em><b>In Event</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERMEDIATE_EVENT__IN_EVENT = eINSTANCE.getIntermediateEvent_InEvent();

		/**
		 * The meta object literal for the '<em><b>Out Event</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERMEDIATE_EVENT__OUT_EVENT = eINSTANCE.getIntermediateEvent_OutEvent();

		/**
		 * The meta object literal for the '{@link FaultTree.impl.FailureTypeImpl <em>Failure Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see FaultTree.impl.FailureTypeImpl
		 * @see FaultTree.impl.FaultTreePackageImpl#getFailureType()
		 * @generated
		 */
		EClass FAILURE_TYPE = eINSTANCE.getFailureType();

		/**
		 * The meta object literal for the '<em><b>Instance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FAILURE_TYPE__INSTANCE = eINSTANCE.getFailureType_Instance();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FAILURE_TYPE__NAME = eINSTANCE.getFailureType_Name();

		/**
		 * The meta object literal for the '<em><b>Root</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FAILURE_TYPE__ROOT = eINSTANCE.getFailureType_Root();

		/**
		 * The meta object literal for the '{@link FaultTree.impl.FailureInstanceImpl <em>Failure Instance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see FaultTree.impl.FailureInstanceImpl
		 * @see FaultTree.impl.FaultTreePackageImpl#getFailureInstance()
		 * @generated
		 */
		EClass FAILURE_INSTANCE = eINSTANCE.getFailureInstance();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FAILURE_INSTANCE__NAME = eINSTANCE.getFailureInstance_Name();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FAILURE_INSTANCE__TYPE = eINSTANCE.getFailureInstance_Type();

		/**
		 * The meta object literal for the '<em><b>Root</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FAILURE_INSTANCE__ROOT = eINSTANCE.getFailureInstance_Root();

		/**
		 * The meta object literal for the '<em><b>Previous Failure</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FAILURE_INSTANCE__PREVIOUS_FAILURE = eINSTANCE.getFailureInstance_PreviousFailure();

		/**
		 * The meta object literal for the '<em><b>Previous Error</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FAILURE_INSTANCE__PREVIOUS_ERROR = eINSTANCE.getFailureInstance_PreviousError();

		/**
		 * The meta object literal for the '<em><b>Event</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FAILURE_INSTANCE__EVENT = eINSTANCE.getFailureInstance_Event();

		/**
		 * The meta object literal for the '{@link FaultTree.impl.BasicEventImpl <em>Basic Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see FaultTree.impl.BasicEventImpl
		 * @see FaultTree.impl.FaultTreePackageImpl#getBasicEvent()
		 * @generated
		 */
		EClass BASIC_EVENT = eINSTANCE.getBasicEvent();

		/**
		 * The meta object literal for the '<em><b>Instance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BASIC_EVENT__INSTANCE = eINSTANCE.getBasicEvent_Instance();

		/**
		 * The meta object literal for the '<em><b>Probability</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BASIC_EVENT__PROBABILITY = eINSTANCE.getBasicEvent_Probability();

		/**
		 * The meta object literal for the '<em><b>Out Event</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BASIC_EVENT__OUT_EVENT = eINSTANCE.getBasicEvent_OutEvent();

		/**
		 * The meta object literal for the '{@link FaultTree.impl.UndevelopedEventImpl <em>Undeveloped Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see FaultTree.impl.UndevelopedEventImpl
		 * @see FaultTree.impl.FaultTreePackageImpl#getUndevelopedEvent()
		 * @generated
		 */
		EClass UNDEVELOPED_EVENT = eINSTANCE.getUndevelopedEvent();

		/**
		 * The meta object literal for the '{@link FaultTree.impl.ErrorTypeImpl <em>Error Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see FaultTree.impl.ErrorTypeImpl
		 * @see FaultTree.impl.FaultTreePackageImpl#getErrorType()
		 * @generated
		 */
		EClass ERROR_TYPE = eINSTANCE.getErrorType();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ERROR_TYPE__NAME = eINSTANCE.getErrorType_Name();

		/**
		 * The meta object literal for the '<em><b>Error</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ERROR_TYPE__ERROR = eINSTANCE.getErrorType_Error();

		/**
		 * The meta object literal for the '<em><b>Root</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ERROR_TYPE__ROOT = eINSTANCE.getErrorType_Root();

		/**
		 * The meta object literal for the '{@link FaultTree.impl.ErrorInstanceImpl <em>Error Instance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see FaultTree.impl.ErrorInstanceImpl
		 * @see FaultTree.impl.FaultTreePackageImpl#getErrorInstance()
		 * @generated
		 */
		EClass ERROR_INSTANCE = eINSTANCE.getErrorInstance();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ERROR_INSTANCE__NAME = eINSTANCE.getErrorInstance_Name();

		/**
		 * The meta object literal for the '<em><b>Error</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ERROR_INSTANCE__ERROR = eINSTANCE.getErrorInstance_Error();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ERROR_INSTANCE__TYPE = eINSTANCE.getErrorInstance_Type();

		/**
		 * The meta object literal for the '<em><b>Root</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ERROR_INSTANCE__ROOT = eINSTANCE.getErrorInstance_Root();

		/**
		 * The meta object literal for the '{@link FaultTree.impl.ORImpl <em>OR</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see FaultTree.impl.ORImpl
		 * @see FaultTree.impl.FaultTreePackageImpl#getOR()
		 * @generated
		 */
		EClass OR = eINSTANCE.getOR();

		/**
		 * The meta object literal for the '{@link FaultTree.impl.ANDImpl <em>AND</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see FaultTree.impl.ANDImpl
		 * @see FaultTree.impl.FaultTreePackageImpl#getAND()
		 * @generated
		 */
		EClass AND = eINSTANCE.getAND();

		/**
		 * The meta object literal for the '{@link FaultTree.impl.XORImpl <em>XOR</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see FaultTree.impl.XORImpl
		 * @see FaultTree.impl.FaultTreePackageImpl#getXOR()
		 * @generated
		 */
		EClass XOR = eINSTANCE.getXOR();

		/**
		 * The meta object literal for the '{@link FaultTree.impl.PriorANDImpl <em>Prior AND</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see FaultTree.impl.PriorANDImpl
		 * @see FaultTree.impl.FaultTreePackageImpl#getPriorAND()
		 * @generated
		 */
		EClass PRIOR_AND = eINSTANCE.getPriorAND();

		/**
		 * The meta object literal for the '{@link FaultTree.impl.InhibitImpl <em>Inhibit</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see FaultTree.impl.InhibitImpl
		 * @see FaultTree.impl.FaultTreePackageImpl#getInhibit()
		 * @generated
		 */
		EClass INHIBIT = eINSTANCE.getInhibit();

		/**
		 * The meta object literal for the '{@link FaultTree.impl.RootImpl <em>Root</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see FaultTree.impl.RootImpl
		 * @see FaultTree.impl.FaultTreePackageImpl#getRoot()
		 * @generated
		 */
		EClass ROOT = eINSTANCE.getRoot();

		/**
		 * The meta object literal for the '<em><b>Hazard</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROOT__HAZARD = eINSTANCE.getRoot_Hazard();

		/**
		 * The meta object literal for the '<em><b>Gate</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROOT__GATE = eINSTANCE.getRoot_Gate();

		/**
		 * The meta object literal for the '<em><b>Event</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROOT__EVENT = eINSTANCE.getRoot_Event();

		/**
		 * The meta object literal for the '<em><b>Failure instance</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROOT__FAILURE_INSTANCE = eINSTANCE.getRoot_Failure_instance();

		/**
		 * The meta object literal for the '<em><b>Failure type</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROOT__FAILURE_TYPE = eINSTANCE.getRoot_Failure_type();

		/**
		 * The meta object literal for the '<em><b>Error instance</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROOT__ERROR_INSTANCE = eINSTANCE.getRoot_Error_instance();

		/**
		 * The meta object literal for the '<em><b>Error type</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROOT__ERROR_TYPE = eINSTANCE.getRoot_Error_type();

	}

} //FaultTreePackage
